<?php

// Set debug level
if(ARCHITECT_ADMIN_DEBUG)
{
	error_reporting(E_ALL);
	ini_set('display_errors', true);
}

/**
 * WordPress Mobile Admin Control Panel
 * 
 * @access public
 * @return void
 */
if(!function_exists('architect_admin_options_page'))
{
	function architect_admin_options_page()
	{
		if (isset($_POST['info_update'])) 
		{
			$updateOption = false;
			
			// Save Dev Key
			if(architect_admin_save_option('architect_admin_devkey')) $updateOption = true;
			// Save "posted from.."
			if(architect_admin_save_option('architect_admin_show_postedfrom')) $updateOption = true;
			// Save "posted from.." text
			if(architect_admin_save_option('architect_admin_postedfrom')) $updateOption = true;
		}
		
		if(isset($updateOption) && $updateOption == true)
		{
			echo "<div class='updated fade'><p><strong>Settings saved</strong></p></div>";
		}
			
		echo '<div class="wrap">';
		
		if(get_option('architect_admin_devkey') == '' OR !get_option('architect_admin_devkey'))
		{
			echo '<div class="updated" style="background:#F24318;color:#000;border-color:#B23112;"><p><strong>You haven\'t saved your free Wapple Architect Dev Key, get one today from <a href="http://wapple.net/register/plugins-signup.htm?trk=wpma" style="color:#000;">Wapple</a></strong>. Once you have it, enter it below</p></div>';
		}
		if(!function_exists('simplexml_load_string'))
		{
			echo '<div class="updated" style="background:#F24318;color:#000;border-color:#B23112;"><p>You do not have simpleXML installed, this plugin needs simpleXML in order to parse XML returned from Wapple\'s web services</p></div>';
		}

		echo '<form method="post" action="options-general.php?page=wordpress-mobile-admin.php" enctype="multipart/form-data">';
		echo architect_admin_header_mobile('2', 'WordPress Mobile Administration Settings');	
		
		echo architect_table_start();
		// Dev Key
		echo architect_admin_option('input', array('label' => 'Wapple Architect Dev Key', 'name' => 'architect_admin_devkey', 'value' => get_option('architect_admin_devkey'), 'description' => '<br />Enter your newly acquired Dev Key from Wapple (You can use the same one for the Wapple Architect Mobile Plugin)'));
		
		// Add a "posted from.." text
		echo architect_admin_option('select', array('label' => 'Show "Posted from Mobile"', 'name' => 'architect_admin_show_postedfrom', 'options' => array('1' => 'Yes', '0' => 'No'), 'value' => get_option('architect_admin_show_postedfrom'), 'description' => '<br />Add text at the bottom of your post to say "Posted from Mobile"'));
	
		// "Posted from.." text
		echo architect_admin_option('input', array('label' => '"Posted from Mobile" text', 'name' => 'architect_admin_postedfrom', 'value' => stripslashes(htmlspecialchars(get_option('architect_admin_postedfrom'))), 'description' => '<br />Defined the "Posted from Mobile" text you want added at the bottom of a post. Use {manufacturer} for handset manufacturer and {model} for handset model'));
		
		echo '</table>';
		
		echo '<p><strong>Did you know that you can use your dev key from Wapple with another great plugin?</strong></p>';
		echo '<p>The Wapple Architect Mobile Plugin for WordPress mobilizes your blog so your visitors can read your posts whilst they are on their mobile phone!</p>';
		echo '<p>Head over to <a href="http://wordpress.org/extend/plugins/wapple-architect/">http://wordpress.org/extend/plugins/wapple-architect/</a> and install it now!</p>';
		
		echo '<table class="form-table" cellspacing="2" cellpadding="5" width="100%"><tr><td><p class="submit"><input class="button-primary" type="submit" name="info_update" value="Save Changes" /></p></td></tr></table>';
		echo '</form>
		</div>';
	}
}

/**
 * Do device detection
 * 
 * @access public
 * @param array $options
 * @return void
 */
if(!function_exists('adminDeviceDetection'))
{
	function adminDeviceDetection($options = array())
	{
		if(isset($_REQUEST['architectBypass']) AND $_REQUEST['architectBypass'] == true)
		{
			return false;
		}
		
		// Setup a global SOAP client so we can use the same one in the theme
		global $adminWaplSoapClient;
		// Setup global headers so we don't have to get them twice
		global $adminWaplHeaders;
		
		// Which communication method do we want to use?
		if(function_exists('curl_init'))
		{
			// Communicating via REST
			define('ARCHITECT_DO_SOAP', false);
			define('ARCHITECT_DO_REST', true);
		} else if(class_exists('SoapClient'))
		{
			// Check if the SOAP client is up
			if(!@file_get_contents('http://webservices.wapple.net/info.txt'))
			{
				define('ARCHITECT_DO_SOAP', false);
				define('ARCHITECT_DO_REST', false);
				return false;
			} else
			{
				// Communicating via SOAP
				define('ARCHITECT_DO_SOAP', true);
				define('ARCHITECT_DO_REST', false);
			}
		} else
		{
			return false;
		}
		if(!function_exists('simplexml_load_string'))
		{
			return false;
		}
		
		// Create the SOAP client
		if(ARCHITECT_DO_SOAP)
		{
			$adminWaplSoapClient = __getAdminSoapClient();
		} else
		{
			$adminWaplSoapClient = null;
		}
		// Get device / browser header information 
		$adminWaplHeaders = __getAdminHeaders();
	
		// If __testForMobile() comes back true, amend template path
		if(__adminTestForMobile())
		{
			$file = ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.basename($_SERVER['SCRIPT_NAME']);
	
			if(file_exists($file))
			{
				include($file);
				exit(0);
			}
		}
	}
}

/**
 * Get a SOAP client
 * @return mixed
 */
if(!function_exists('__getAdminSoapClient'))
{
	function __getAdminSoapClient()
	{
		if(ARCHITECT_DEBUG)
		{
			return false;
		}
		if(ARCHITECT_DO_SOAP)
		{
			return new SoapClient('http://webservices.wapple.net/wapl.wsdl', array('exceptions' => 0));
		} else
		{
			return false;
		}	
	}
}

/**
 * Build device header array that SOAP can use
 * @return array
 */
if(!function_exists('__getAdminHeaders'))
{
	function __getAdminHeaders()
	{
		if(ARCHITECT_DO_SOAP)
		{
			$headers = array();
			foreach($_SERVER as $key => $val)
			{
				$headers[] = array('name' => $key, 'value' => $val);
			}
			return $headers;
		} else
		{
			$headers = '';
			foreach($_SERVER as $key => $val)
			{
				$headers .= $key.':'.$val.'|';
			}
			return $headers;
		}
	}
}

/**
 * Perform a device detection check
 * @return boolean
 */
if(!function_exists('__adminTestForMobile'))
{
	function __adminTestForMobile()
	{
		global $adminWaplSoapClient;
		global $adminWaplHeaders;
		
		if(isset($_REQUEST['mobile']) && $_REQUEST['mobile'] == 0)
		{
			setcookie('isMobile', "", time()-3600, '/');
			setcookie('isMobile', "0", time()+3600, '/');
			return false;
		} else if(isset($_REQUEST['mobile']) && $_REQUEST['mobile'] == 1)
		{
			setcookie('isMobile', "", time()-3600, '/');
			setcookie('isMobile', "1", time()+3600, '/');
			return true;
		}
		
		if(!get_option('architect_admin_devkey'))
		{
			return false;
		}
		
		// Check for existence of a cookie
		if(isset($_COOKIE['isMobile']) AND $_COOKIE['isMobile'] == true)
		{
			return true;
		} else if(isset($_COOKIE['isMobile']) AND $_COOKIE['isMobile'] == false)
		{
			return false;
		} else
		{
			if(ARCHITECT_DEBUG)
			{
				return true;
			}
			if(ARCHITECT_DO_SOAP)
			{
				// Test for mobile
				$params = array(
					'devKey' => get_option('architect_admin_devkey'),
					'deviceHeaders' => $adminWaplHeaders
				);
			
				$result = @$adminWaplSoapClient->getMobileDevice($params);
				if(is_soap_fault($result))
				{
					// There is a SOAP error! probably a dev key error
					return false;
				}  else
				{
					$xml = simplexml_load_string($result);
					
					if($xml->mobile_device == 1)
					{
						setcookie('architectMobileInformation', 'manufacturer='.trim($xml->manufacturer).'|model='.trim($xml->model), time()+3600, '/');
												
						// Set a cookie to remember the outcome!
						setcookie('isMobile', true, time()+3600, '/');
						return true;
					} else
					{
						setcookie('isMobile', false, time()+3600, '/');
						return false;
					}
				}
			} else if(ARCHITECT_DO_REST)
			{
				$postfields = array(
					'devKey' => get_option('architect_admin_devkey'),
					'headers' => $adminWaplHeaders
				);
				
				$c = curl_init();
				curl_setopt($c, CURLOPT_URL, 'http://webservices.wapple.net/getMobileDevice.php');
				curl_setopt($c, CURLOPT_RETURNTRANSFER, true);
				curl_setopt($c, CURLOPT_POST, 1);
				curl_setopt($c, CURLOPT_POSTFIELDS, $postfields);
				
				$result = curl_exec($c);
				$xml = simplexml_load_string($result);
				
				if($xml->mobile_device == 1)
				{
					setcookie('architectMobileInformation', 'manufacturer='.trim($xml->manufacturer).'|model='.trim($xml->model), time()+3600, '/');
					
					setcookie('isMobile', true, time()+3600, '/');
					return true;
				} else
				{
					setcookie('architectMobileInformation', '', time()-3600, '/');
					setcookie('isMobile', "0", time()+3600, '/');
					return false;
				}
			}
		}
	}
}

/**
 * Convert any other chars
 * 
 * @param string $string
 * @access public
 * @return string
 */
if(!function_exists('architectAdminCharsOther'))
{
	function architectAdminCharsOther($string)
	{
		$chars = array(
			'’' => '&#39;', '—' => '&#45;', '«' => '&#171;', '»' => '&#187;', '&laquo;' => '&#171;',
			'&raquo;' => '&#187;', '–' => '&#45;', '&hellip;' => '&#8230;', '&nbsp;' => '&#160;', '&amp;nbsp;' => '&#160;'
		);
		return str_replace(array_keys($chars), array_values($chars), $string);
	}
}

if(!function_exists('esc_url'))
{
	function esc_url( $url, $protocols = null ) {
		return clean_url( $url, $protocols, 'display' );
	}
}

if(!function_exists('architectAdminError'))
{
	function architectAdminError()
	{
		$_SERVER['SCRIPT_NAME'] = 'permissions-error.php';
		adminDeviceDetection();
	}
}

if(!function_exists('architect_admin_save_option'))
{
	function architect_admin_save_option($option, $options = array())
	{
		// Strip tags out
		if(isset($options['stripTags']) && $options['stripTags'] == true)
		{
			$tagAllow = '';
			if(!empty($options['tagAllow']))
			{
				$tagAllow .= '<';
				$tagAllow .= implode('><', $options['tagAllow']);
				$tagAllow .= '>';
			}
			$_POST[$option] = strip_tags($_POST[$option], $tagAllow);
		} 
		
		if($_POST[$option] != get_option($option))
		{
			update_option($option, $_POST[$option]);
			return true;
		}
	}
}

if(!function_exists('architect_admin_header_mobile'))
{
	function architect_admin_header_mobile($h, $value)
	{
		return '<tr><td colspan="2" class="architectHeader"><h'.$h.'><img src="'.WP_PLUGIN_URL.'/'.get_wpma_plugin_base().'/wp-admin/architect32.png" alt="Wapple Architect" class="architectHeaderImage" />'.$value.'</h'.$h.'></td></tr>';
	}
}

if(!function_exists('architect_table_start'))
{
	function architect_table_start()
	{
		return '<table class="form-table architectTable" cellspacing="2" cellpadding="5">';
	}
}

if(!function_exists('architect_admin_option'))
{
	function architect_admin_option($type, $options = array())
	{
		$string  = '<tr>';
		if($type != 'text')
		{
			$string .= '<th width="30%" valign="top" class="architectCell">';
			
			if(isset($options['name']))
			{
				$string .= '<label for="'.$options['name'].'">'.$options['label'].': </label>';
			}
			$string .= '</th>';
			$string .= '<td>';
		}  else
		{
			$string .= '<td colspan="2">';
		}
		
		switch($type)
		{
			case 'input' : 
				if(!isset($options['size']))
				{
					$options['size'] = 40;
				}
				if(isset($options['before']) AND $options['before'] != '')
				{
					$string .= $options['before'];
				}
				$string .= '<input';
				
				if($options['size'] == 40)
				{
					$string .= ' class="regular-text architectInput"';
				}
				$string .= ' size="'.$options['size'].'" type="text" name="'.$options['name'].'" id="'.$options['name'].'" value="'.$options['value'].'" />';
				
				if(isset($options['after']) AND $options['after'] != '')
				{
					$string .= $options['after'];
				}
				break;
			case 'select' :
				$string .= '<select name="'.$options['name'].'" class="architectSelect';
				
				if(isset($options['multiple']) && $options['multiple'] == true)
				{
					$string .= ' architectMultiple" multiple size="5"';
				} else
				{
					$string .= '"';
				}
				
				$string .= '>';
				if(isset($options['multiple']) && $options['multiple'] == true)
				{
					$values = explode('|', $options['value']);
					
					foreach($values as $key => $val)
					{
						$values[$key] = stripslashes(architectCharsOther($val));
					}

					foreach($options['options'] as $val)
					{
						$val = stripslashes($val);
						$string .= '<option value="'.$val.'"';
						
						if(in_array(architectCharsOther($val), $values))
						{
							$string .= ' selected="selected"';
						}
						$string .= '>'.$val.'</option>';
					}
				} else
				{
					foreach($options['options'] as $key => $val)
					{
						$string .= '<option value="'.$key.'"';
					
						if($key == $options['value'])
						{
							$string .= ' selected="selected"';
						}
						
						$string .= '>'.$val.'</option>';
					}
				}
				$string .= '</select>';
				break;
			case 'file' :
				$string .= '<input type="file" name="'.$options['name'].'" id="'.$options['name'].'" class="architectInput" />';
				break;
			case 'image' :
				$string .= '<img src="'.$options['src'].'" alt="'.$options['alt'].'" class="architectImage" />';
				break;
			case 'textarea' :
				if(!isset($options['rows']))
				{
					$options['rows'] = 25;
				}
				if(!isset($options['cols']))
				{
					$options['cols'] = 70;
				}
				$string .= '<textarea class="architectTextarea" id="'.$options['name'].'" name="'.$options['name'].'" rows="'.$options['rows'].'" cols="'.$options['cols'].'">'.$options['value'].'</textarea>';
				break;
			case 'text' :
				$string .= '<p>';
				if(isset($options['bold'])) $string .= '<strong>';
				if(isset($options['italic'])) $string .= '<em>';
				
				$string .= $options['value'];
				
				if(isset($options['italic'])) $string .= '</em>';
				if(isset($options['bold'])) $string .= '</strong>';
				$string .= '</p>';
				break;
			
		}
		
		if(isset($options['description']) && $type != 'text')
		{
			$string .= '<span class="description">'.$options['description'].'</span>';
		}
		
		$string .= '</td></tr>';
		return $string;
	}
}
?>